package cis690.insight.debug;

import java.util.Vector;

import org.eclipse.debug.core.model.IVariable;
import org.eclipse.draw2d.geometry.Point;

/**
 * 
 * @version May 21, 2004
 * @author charlie
 */
public interface IDebugObject
{
	// hierarchy stuff
	Vector getParents();
	void addParent(IDebugObject parent);
	void remParent(IDebugObject parent);
	Vector getChildren();
	void addChild(IDebugObject child);
	void remChild(IDebugObject child);
	
	// state information
	IDebugModel getDebugModel();
	boolean isThread();
	boolean isSuspended();
	void setSuspended(boolean suspended);
	String getName();
	IVariable[] getVars();
	Point getXY();
	void setXY(Point xy);
	void setShade(boolean shadeMode);
	boolean isShade();
	
	// identification
	Object getObj();
	
	// the two key methods
	void open(IVariable var);
	void close(IVariable var);
}
