package cis690.insight.figures;

import org.eclipse.draw2d.PolylineConnection;

/**
 * This is a convenience class to ensure clever equality testing.
 * @version May 22, 2004
 * @author charlie
 */
public class ObjConnection extends PolylineConnection
{
	private Object m_o1;
	private Object m_o2;
	
	public ObjConnection(Object o1, Object o2)
	{
		m_o1 = o1;
		m_o2 = o2;
	}
	
	/** update target anchor to be the same as the new version */
	public void renewTarget(ObjConnection newVersion)
	{
		setTargetAnchor(newVersion.getTargetAnchor());
	}
	
	public int hashCode()
	{
		return m_o1.hashCode() + m_o2.hashCode();	
	}
	
	public boolean equals(Object obj)
	{
		return obj.hashCode() == hashCode();	
	}
}
