package cis690.insight.parts;

import org.eclipse.draw2d.geometry.Point;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.GraphicalEditPart;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.XYLayoutEditPolicy;
import org.eclipse.gef.requests.CreateRequest;

import cis690.insight.debug.DebugObject;

/**
 * 
 * @version May 18, 2004
 * @author charlie
 */
public class EnclosingLayoutPolicy extends XYLayoutEditPolicy
{

	protected Command createAddCommand(EditPart child, Object constraint)
	{
		System.out.println("create add command");
		return null;
	}

	protected Command createChangeConstraintCommand(EditPart child, Object constraint)
	{
		return new ChangeConstraintCommand(child, constraint);
	}

	protected Command getCreateCommand(CreateRequest request)
	{
		System.out.println("get create command");
		return null;
	}

	protected Command getDeleteDependantCommand(Request request)
	{
		System.out.println("get delete dependant command");
		return null;
	}
	
	// -----------------------
	// Command Implementations
	// -----------------------
	
	private class ChangeConstraintCommand extends Command
	{
		private GraphicalEditPart i_part;
		private Point i_nextPt;
		
		public ChangeConstraintCommand(EditPart child, Object constraint)
		{
			i_part = (GraphicalEditPart)child;
			i_nextPt = ((Rectangle)constraint).getTopLeft();
		}
		
		// should be, getModel().setX .setY i_part.refreshVisuals
		public void execute()
		{
			DebugObject mod = (DebugObject)i_part.getModel();
			Point tmp = mod.getXY();
			mod.setXY(i_nextPt);
			mod.notifyObservers();
			i_nextPt = tmp;
		}
		
		public void undo()
		{
			execute();
		}
		
		public boolean canUndo()
		{
			return true;	
		}
	}

}
